=== debian/changelog ===
ovito (2.3.3-3+deb8u1) jessie-security; urgency=high

  * Non-maintainer upload.
  * No-change rebuild against botan1.10.

 -- Markus Koschany <apo@debian.org>  Tue, 10 May 2016 18:47:53 +0200

ovito (2.3.3-3) unstable; urgency=medium

  * [63c2552] Disable statistic send to a server by default.
  * [5a5813b] Fix nested examples directory.
  * [6f3ff37] Remove all .DS_Store.gz from ovito-doc.

 -- Anton Gladky <gladk@debian.org>  Thu, 24 Jul 2014 23:17:04 +0200

ovito (2.3.3-2) unstable; urgency=medium

  * [a1a602a] Update list of archs.

 -- Anton Gladky <gladk@debian.org>  Fri, 30 May 2014 09:25:51 +0200

ovito (2.3.3-1) unstable; urgency=medium

  * [ed9fe66] Provide ovito-examples by ovito-doc.
  * [c0c572b] Build ovito only on 
              any-amd64 any-i386 any-powerpc any-s390 any-mips.
  * [942ec5a] Imported Upstream version 2.3.3
  * [0fcba66] Ignore quilt dir
  * [0a00c0f] Install examples.
  * [1338fab] Add build-dependency on libswscale-dev.
  * [27c62d4] Fix build-options in debian/rules. 
              Thanks to Moritz Muehlenhoff <jmm@debian.org>. (Closes: #748157)

 -- Anton Gladky <gladk@debian.org>  Thu, 29 May 2014 21:58:42 +0200

ovito (2.3.3~beta1~git7e66e42-1) unstable; urgency=medium

  * [ce147a6] Disable Tachyon on powerpc.
  * [7003db6] Do not build CRYSTALANALYSIS on armel because of absent cgal.
  * [aa60949] Imported Upstream version 2.3.3~beta1~git7e66e42. 
              (Closes: #745668)

 -- Anton Gladky <gladk@debian.org>  Tue, 29 Apr 2014 20:49:51 +0200

ovito (2.3.2~git8178817e-2) unstable; urgency=medium

  * [b124370] Enable TACHYON again, disable it only on kfreebsd*.
  * [3029a45] Do not build tachyon on hurd-i386.
  * [40e2052] Remove libcgal-dev from BD on armel.
  * [47fa8cb] Add libglu1-mesa-dev and libgl1-mesa-dev 
              on armel and armhf to let it build there.
  * [b9e62be] Add dummy autotest.

 -- Anton Gladky <gladk@debian.org>  Fri, 11 Apr 2014 20:04:52 +0200

ovito (2.3.2~git8178817e-1) unstable; urgency=medium

  * [106c6b6] Imported Upstream version 2.3.2~git8178817e
  * [5e86b4f] Remove patches, applied by upstream.
  * [c5f1b03] Add some more packages in Build-Depends.

 -- Anton Gladky <gladk@debian.org>  Tue, 08 Apr 2014 23:46:34 +0200

ovito (2.2.4-2) unstable; urgency=medium

  * [782d8bc] Disable Tachyon plugin. FTBFS on many platforms.
  * [cf6ad96] Disable including cpuid.h as it is absent on some archs.
  * [6190d35] Use packaged muparser instead of embedded version.
  * [27aaf43] Ignore quilt dir.

 -- Anton Gladky <gladk@debian.org>  Mon, 07 Apr 2014 21:11:23 +0200

ovito (2.2.4-1) unstable; urgency=medium

  * [80c58ad] Imported Upstream version 2.2.4. (Closes: #740549)
  * [d81a0f1] Update build-depends, remove ovito-examples binary.
  * [d7e65d7] Remove patches.
  * [23c5984] Add pixmaps.

 -- Anton Gladky <gladk@debian.org>  Sun, 16 Mar 2014 15:24:24 +0100
