=== debian/control ===
Source: ovito
Section: science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Anton Gladky <gladk@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 9),
 docbook-xml,
 docbook-xsl,
 docbook-xsl-doc-html,
 libavcodec-dev,
 libavdevice-dev,
 libboost-dev,
 libboost-iostreams-dev,
 libboost-python-dev,
 libbotan1.10-dev,
 libcgal-dev [!armel],
 libglu1-mesa-dev [armel armhf],
 libgl1-mesa-dev [armel armhf],
 libgsl0-dev,
 libhdf5-dev,
 libmuparser-dev (>= 2.1.0),
 libnetcdf-dev,
 libqscintilla2-dev,
 libqt5opengl5-dev,
 libqcustomplot-dev (>=1.2.0),
 libswscale-dev,
 libtachyon-dev [!hurd-i386],
 python-dev,
 qt5-default,
 qtbase5-dev-tools,
 qtscript5-dev,
 xsltproc,
 zlib1g-dev
Standards-Version: 3.9.5
XS-Testsuite: autopkgtest
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/ovito.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/ovito.git
Homepage: http://www.ovito.org/

Package: ovito
Architecture: any-amd64 any-i386 any-powerpc s390x mips mipsel
Depends:
 python,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 ovito-doc
Suggests:
 povray
Description: visualization and analysis tool for atomistic simulation data
 OVITO is a visualization and analysis software for atomistic
 simulation data. Being a single integrated application it covers both
 the analysis and the visualization of large-scale atomistic datasets
 produced by molecular dynamics/statics and Monte-Carlo simulation
 codes. Its name is an acronym for Open Visualization Tool,
 emphasizing that the software has been designed with flexibility and
 extensibility in mind.

Package: ovito-doc
Architecture: all
Depends:
 ${misc:Depends}
Provides:
 ovito-examples
Suggests:
 ovito,
Section: doc
Description: documentation for ovito
 OVITO aka Open Visualization Tool is a scientific visualization and
 analysis software for atomistic simulation data.
 .
 This package contains the User Manual for ovito.
