=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel

extra_flags += \
	-DOVITO_BUILD_DOCUMENTATION=TRUE \
	-DOVITO_BUILD_PLUGIN_SCRIPTING=TRUE \
	-DOVITO_BUILD_PLUGIN_NETCDF=TRUE \
	-DOVITO_VIDEO_OUTPUT_SUPPORT=ON \
	-DOVITO_USE_SYSTEM_QCUSTOMPLOT=ON

ifneq (,$(filter $(DEB_HOST_ARCH), kfreebsd-amd64 kfreebsd-i386 hurd-i386 powerpc))
	extra_flags += -DOVITO_BUILD_PLUGIN_TACHYON=FALSE
endif

ifeq (,$(filter $(DEB_HOST_ARCH), armel))
	extra_flags += -DOVITO_BUILD_PLUGIN_CRYSTALANALYSIS=TRUE
endif

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

override_dh_install:
	dh_install --list-missing
	find ./debian/ovito -type d -empty -delete
	find ./ -name "*DS_Store.gz" | xargs rm -f
